api/urls.py
from django.urls import path, include
from rest_framework import routers
from api import views

# Routers - provee una manera facil de redirigir a los endpoint
# metodos accecibles GET, POST, PUT, DELETE
router = routers.DefaultRouter()

# rutas de app clientes
router.register(r'localidades', views.LocalidadsViewSet)
router.register(r'clientes', views.ClienteViewSet)
router.register(r'instalaciones', views.InstalacionViewSet)
router.register(r'contadores', views.ContadorViewSet)
router.register(r'pagos', views.PagoViewSet)

# rutas de app equipos
router.register(r'modems', views.ModemViewSet)
router.register(r'emisoras', views.EmisoraViewSet)
router.register(r'antenas', views.AntenaViewSet)

# Wire up our API using automatic URL routing.
# Additionally, we include login URLs for the browsable API.
urlpatterns = [
    path('', include(router.urls)),
    # path('api-auth/', include('rest_framework.urls', namespace='rest_framework'))
]

app_equipos/urls.py
from django.urls import path
from .views import *

urlpatterns = [
    # crud de modems
    path('modems/', ModemView.as_view(), name='modems_list'),
    path('modems/new', ModemNew.as_view(), name='modems_new'),
    path('modems/edit/<int:pk>', ModemEdit.as_view(), name='modems_edit'),
    path('modems/delete/<int:pk>', ModemDelete.as_view(), name='modems_delete'),
    
    # crud de antenas
    path('antenas/', AntenaView.as_view(), name='antenas_list'),
    path('antenas/new', AntenaNew.as_view(), name='antenas_new'),
    path('antenas/edit/<int:pk>', AntenaEdit.as_view(), name='antenas_edit'),
    path('antenas/delete/<int:pk>', AntenaDelete.as_view(), name='antenas_delete'),
    
    # crud de emisoras
    path('emisoras/', EmisoraView.as_view(), name='emisoras_list'),
    path('emisoras/new', EmisoraNew.as_view(), name='emisoras_new'),
    path('emisoras/edit/<int:pk>', EmisoraEdit.as_view(), name='emisoras_edit'),
    path('emisoras/delete/<int:pk>', EmisoraDelete.as_view(), name='emisoras_delete'),
]

zanet/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from rest_framework.documentation import include_docs_urls
from django.conf.urls.static import static

urlpatterns = [
    path('', include(('bases.urls', 'bases'), namespace="bases")),
    path('', include(('app_clientes.urls', 'app_clientes'), namespace="app_clientes")),
    path('', include(('app_equipos.urls', 'app_equipos'), namespace="app_equipos")),
    path('', include(('app_perfiles.urls', 'app_perfiles'), namespace="app_perfiles")),
    path('', include(('app_publicidad.urls', 'app_publicidad'), namespace="app_publicidad")),
    path('admin/', admin.site.urls),
    path('api/v1/', include('api.urls')),
    path('docs/', include_docs_urls(title='API Documentación')),
]

urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

app_equipos/models.py
from django.db import models
from app_clientes.models import Cliente

# Create your models here.
class Modem(models.Model):
    """ modelo que representa un modem"""
    marca = models.CharField(max_length=45, null=False, blank=False)
    clave_wifi = models.CharField(max_length=45, null=True, blank=True)
    gateway = models.CharField(max_length=45, null=True, blank=True)
    imagen = models.ImageField(upload_to='modems', null=True, blank=True)
    notas = models.CharField(max_length=200, null=True, blank=True)

    # relaciones
    # un cliente recibe 1 o mas modems en su instalación
    cliente = models.ForeignKey(Cliente, on_delete=models.CASCADE)    

    def __str__(self):
        """ Descripción del modelo modem """
        return '{}'.format(self.marca)

    # def save(self):
    #     """ el nombre del modem lo guardamos en mayúsculas"""
    #     self.marca = self.marca.upper()
    #     super(Modem, self).save()

    class Meta:
        """ nombre en plural(Muchos) del modelo"""
        verbose_name_plural = "Modems"


class Emisora(models.Model):
    """ modelo que representa una emisora"""
    nombre = models.CharField(max_length=45, blank=False, null=False)
    ssid = models.CharField(max_length=45, blank=True, null=True)
    direccion_mac = models.CharField(max_length=45, blank=True, null=True)
    direccion_ip = models.CharField(max_length=45, blank=True, null=True)
    ancho_de_canal = models.CharField(max_length=45, blank=True, null=True)
    frecuencia = models.IntegerField(blank=True, null=True)
    ubicacion = models.CharField(max_length=45, blank=True, null=True)
    notas = models.CharField(max_length=200, null=True, blank=True)    

    def __str__(self):
        """ Descripción del modelo emisora """
        return '{}'.format(self.nombre)

    class Meta:
        """ nombre en plural(Muchos) del modelo"""
        verbose_name_plural = "Emisoras"


class Antena(models.Model):
    """ modelo que representa una antena"""
    marca = models.CharField(max_length=45, null=False, blank=False)
    ip_interna = models.CharField(max_length=45, null=True, blank=True)
    ip_externa = models.CharField(max_length=45, null=True, blank=True)
    gateway = models.CharField(max_length=45, null=True, blank=True)
    signal_min = models.IntegerField(null=True, blank=True)
    signal_actual = models.IntegerField(null=True, blank=True)
    imagen = models.ImageField(upload_to='antenas', null=True, blank=True)
    notas = models.CharField(max_length=200, null=True, blank=True)

    # relaciones
    # un cliente recibe 1 antena en su instalación
    cliente = models.ForeignKey(Cliente, on_delete=models.CASCADE)
    # una antena esta conectada en una emisora
    emisora = models.ForeignKey(Emisora, on_delete=models.CASCADE)

    def __str__(self):
        """ Descripción del modelo antena """
        return '{}'.format(self.marca)

    # def save(self):
    #     """ el nombre de la antena lo guardamos en mayúsculas"""
    #     self.marca = self.marca.upper()
    #     super(Antena, self).save()

    class Meta:
        """ nombre en plural(Muchos) del modelo"""
        verbose_name_plural = "Antenas"

app_equipos/forms.py
from django.contrib.admin.widgets import AutocompleteSelect
from django.contrib import admin
from django import forms
from django.core.exceptions import ValidationError
from .models import *

class ModemsForm(forms.ModelForm):
    """ form de modems"""
    
    class Meta:
        model = Modem
        fields = '__all__'  
        
    def __init__(self, *args, **kwargs):
        """ método que itera los campos del form y agrega la clase form-control de bootstrap a los input"""
        super().__init__(*args, **kwargs)
        for field in iter(self.fields):
            self.fields[field].widget.attrs.update({
                'class': 'form-control'
            }) 
        
        # al select y/o combo box de forma_de_pago le agregamos un valor por defecto        
        self.fields['cliente'].empty_label = 'Seleccione el cliente..' 
        
class AntenasForm(forms.ModelForm):
    """ form de antenas"""
    
    class Meta:
        model = Antena
        fields = '__all__' 
        
    def __init__(self, *args, **kwargs):
        """ método que itera los campos del form y agrega la clase form-control de bootstrap a los input"""
        super().__init__(*args, **kwargs)
        for field in iter(self.fields):
            self.fields[field].widget.attrs.update({
                'class': 'form-control'
            }) 
        
        # al select y/o combo box de cliente le agregamos un valor por defecto        
        self.fields['cliente'].empty_label = 'Seleccione el cliente..' 
        self.fields['emisora'].empty_label = 'Seleccione la emisora..' 
        
class EmisorasForm(forms.ModelForm):
    """ form de emisoras"""
    
    class Meta:
        model = Emisora
        fields = '__all__' 
        
    def __init__(self, *args, **kwargs):
        """ método que itera los campos del form y agrega la clase form-control de bootstrap a los input"""
        super().__init__(*args, **kwargs)
        for field in iter(self.fields):
            self.fields[field].widget.attrs.update({
                'class': 'form-control'
            }) 
        
        

app_equipos/views.py
from django.shortcuts import render, redirect, get_object_or_404
from django.views.generic import *
from django.urls import reverse_lazy
from django.contrib import messages
from .models import *
from .views import *
from .forms import *
from bases.views import Sin_Privilegios

from django.contrib.auth.mixins import LoginRequiredMixin, PermissionRequiredMixin
from django.contrib.messages.views import SuccessMessageMixin
from django.contrib.auth.decorators import login_required, permission_required
from django.contrib import messages
from django.contrib.messages.views import SuccessMessageMixin

class ModemView(Sin_Privilegios, ListView):
    """ vista basada en clase para listar modems"""
    permission_required = "app_equipos.view_modem"
    model = Modem
    template_name = "app_equipos/modems_list.html"
    context_object_name = "obj" 
    
class ModemNew(Sin_Privilegios, SuccessMessageMixin, CreateView):
    """ vista basada en clase para llenar form de modems"""
    permission_required = "app_equipos.add_modem"
    model = Modem
    template_name = "app_equipos/modems_form.html"
    context_object_name = "obj"
    form_class = ModemsForm 
    success_message = "Modem agregado satisfactoriamente.."
    success_url = reverse_lazy("app_equipos:modems_list") 
    
class ModemEdit(Sin_Privilegios, SuccessMessageMixin, UpdateView):
    """ vista basada en clase para editar form de modems"""
    permission_required = "app_equipos.change_modem"
    model = Modem
    template_name = "app_equipos/modems_form.html"
    context_object_name = "obj"
    form_class = ModemsForm   
    success_message = "Modem actualizado satisfactoriamente.."
    success_url = reverse_lazy("app_equipos:modems_list")
    
class ModemDelete(Sin_Privilegios, SuccessMessageMixin, DeleteView):
    """ vista basada en clase para eliminar un modem"""
    permission_required = "app_equipos.delete_modem"
    model = Modem
    template_name = "app_equipos/modems_del.html"
    context_object_name = "obj"
    success_message = "Modem eliminado satisfactoriamente.."
    success_url = reverse_lazy("app_equipos:modems_list")
    
# ---------------------------------------------------------------------------------
# ---------------------------------------------------------------------------------
    
class AntenaView(Sin_Privilegios, ListView):
    """ vista basada en clase para listar las antenas"""
    permission_required = "app_equipos.view_antena"
    model = Antena
    template_name = "app_equipos/antenas_list.html"
    context_object_name = "obj" 
    
class AntenaNew(Sin_Privilegios, SuccessMessageMixin, CreateView):
    """ vista basada en clase para llenar form de antenas"""
    permission_required = "app_equipos.add_antena"
    model = Antena
    template_name = "app_equipos/antenas_form.html"
    context_object_name = "obj"
    form_class = AntenasForm
    success_message = "Antena agregada satisfactoriamente.."
    success_url = reverse_lazy("app_equipos:antenas_list") 
    
class AntenaEdit(Sin_Privilegios, SuccessMessageMixin, UpdateView):
    """ vista basada en clase para editar form de antenas"""
    permission_required = "app_equipos.change_antena"
    model = Antena
    template_name = "app_equipos/antenas_form.html"
    context_object_name = "obj"
    form_class = AntenasForm  
    success_message = "Antena actualizada satisfactoriamente.."
    success_url = reverse_lazy("app_equipos:antenas_list")
    
class AntenaDelete(Sin_Privilegios, SuccessMessageMixin, DeleteView):
    """ vista basada en clase para eliminar una antena"""
    permission_required = "app_equipos.delete_antena"
    model = Antena
    template_name = "app_equipos/antenas_del.html"
    context_object_name = "obj"
    success_message = "Antena eliminada satisfactoriamente.."
    success_url = reverse_lazy("app_equipos:antenas_list")
    
# ---------------------------------------------------------------------------------
# ---------------------------------------------------------------------------------
    
class EmisoraView(Sin_Privilegios, ListView):
    """ vista basada en clase para listar las emisoras"""
    permission_required = "app_equipos.view_emisora"
    model = Emisora
    template_name = "app_equipos/emisoras_list.html"
    context_object_name = "obj" 
    
class EmisoraNew(Sin_Privilegios, SuccessMessageMixin, CreateView):
    """ vista basada en clase para llenar form de emisoras"""
    permission_required = "app_equipos.add_emisora"
    model = Emisora
    template_name = "app_equipos/emisoras_form.html"
    context_object_name = "obj"
    form_class = EmisorasForm
    success_message = "Emisora agregada satisfactoriamente.."
    success_url = reverse_lazy("app_equipos:emisoras_list") 
    
class EmisoraEdit(Sin_Privilegios, SuccessMessageMixin, UpdateView):
    """ vista basada en clase para editar form de emisoras"""
    permission_required = "app_equipos.change_emisora"
    model = Emisora
    template_name = "app_equipos/emisoras_form.html"
    context_object_name = "obj"
    form_class = EmisorasForm  
    success_message = "Emisora actualizada satisfactoriamente.."
    success_url = reverse_lazy("app_equipos:emisoras_list")
    
class EmisoraDelete(Sin_Privilegios, SuccessMessageMixin, DeleteView):
    """ vista basada en clase para eliminar una emisora"""
    permission_required = "app_equipos.delete_emisora"
    model = Emisora
    template_name = "app_equipos/emisoras_del.html"
    context_object_name = "obj"
    success_message = "Emisora eliminada satisfactoriamente.."
    success_url = reverse_lazy("app_equipos:emisoras_list")

app_equipos/templates/app_equipos/antenas_del.html
{% extends 'bases/home.html' %}

{% load static %}

{% block content %}
<!-- Content Header (Page header) -->
<div class="content-header">
  <section class="content">
    <div class="container-fluid">
      <div class="row">
        <div class="col-4">
          <form method="post">
            {% csrf_token %}
            <!-- Input addon -->
            <!-- card -->
            <div class="card card-danger">                            
              <div class="card-header">
                <h3 class="card-title text-uppercase">Antenas</h3>

                <div class="col-auto d-flex justify-content-end">
                  <i class="far fa-question-circle fa-2x text-gray-300"></i>                           
                </div>
              </div>

              <!-- card-body -->
              <div class="card-body">
                <div class="col-12">
                  <div class="font-weight-light mb-1" style="font-family: Arial, Helvetica, sans-serif; font-size: large;"> ¿Deseas eliminar la antena del cliente:
                    <span class="text-primary" style="text-decoration-line: line-through;"> {{ obj.cliente }}</span> ?
                  </div>

                  <img class="card-img-top p-4" src="{% static 'dist/img/remove-antena.svg' %}" height="280px" alt="modem">
                    
                    <div class="row mt-2">
                      <div class="col-6">
                        <button type="submit" class="btn btn-danger btn-block"><i class="fas fa-check-circle"></i> Si, Eliminar</button>
                      </div>

                      <div class="col-6">
                        <a href="{% url 'app_equipos:antenas_list' %}" class="btn btn-success btn-block"><span class="fas fa-window-close"></span> Cancelar</a>
                      </div>
                    </div>                                                            
                </div> 
                                
              </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card-header -->
          </div>        
        <!-- /.card -->
        </form>
        <!-- ./form -->
      </div>
    </div>
</div>
</section>
<!-- /.container-fluid -->
</div>
<!-- /.content-header -->
{% endblock content %}

app_equipos/templates/app_equipos/antenas_form.html
{% extends 'bases/home.html' %}

{% load static %}

{% block content %}
<!-- Content Header (Page header) -->
<div class="content-header">
    <section class="content">
        <div class="container-fluid">
            <div class="row">
                <div class="col-12">
                    <div class="row">
                        <div class="col-sm-12 col-md-3 col-lg-3">
                            <div class="card d-flex justify-content-center">
                                <div class="card-body">
                                    
                                    {% if obj.imagen %}
                                        <img class="card-img-top p-3" style="height: 380px;" src="{{ obj.imagen.url }}" alt="img de modem">                                        
                                    {% else %}
                                        <img class="card-img-top p-3" style="height: 380px;" src="{% static 'dist/img/antena.svg' %}"
                                        style="height: 290px; width: 300px;" alt="img del modem">
                                    {% endif %}                                        
                                </div>
                            </div>
                        </div>

                        <div class="col-sm-12 col-md-9 col-lg-9" role="form" enctype="multipart/form-data">
                            <form method="post">
                                {% csrf_token %}

                                <!-- Input addon -->
                                <!-- card -->
                                <div class="card">

                                    {% if obj %}
                                    <div class="card-warning">
                                        {% else %}
                                        <div class="card-success">
                                            {% endif %}

                                            <div class="card-header">
                                                <h3 class="card-title text-uppercase">Antenas</h3>
                                            </div>

                                            <!-- card-body -->
                                            <div class="card-body">

                                                <!-- fila 1 -->
                                                <div class="row mt-2">
                                                    <div class="col-sm-12 col-md-4 col-lg-4">
                                                        <div class="form-group">
                                                            <label for="id_cliente"
                                                                class="text-sm text-uppercase text-black-50"
                                                                style="font-family: Arial, Helvetica, sans-serif;">CLIENTE:
                                                                <i class="fa fa-asterisk badge-warning"></i></label>
                                                                {{ form.cliente }}
                                                        </div>
                                                    </div>

                                                    <div class="col-sm-12 col-md-4 col-lg-4">
                                                        <div class="form-group">
                                                            <label for="id_marca"
                                                                class="text-sm text-uppercase text-black-50"
                                                                style="font-family: Arial, Helvetica, sans-serif;">MODELO DE ANTENA:
                                                                <i class="fa fa-asterisk badge-warning"></i></label>
                                                            {{ form.marca }}
                                                        </div>
                                                    </div>    

                                                    <div class="col-sm-12 col-md-4 col-lg-4">
                                                        <div class="form-group">
                                                            <label for="id_emisora"
                                                                class="text-sm text-uppercase text-black-50"
                                                                style="font-family: Arial, Helvetica, sans-serif;">{{ form.emisora.label }}:
                                                                <i class="fa fa-asterisk badge-warning"></i></label>
                                                                {{ form.emisora }}
                                                        </div>
                                                    </div> 
                                                                                                                                                                                                                                                                
                                                </div>

                                                <!-- fila 2 -->
                                                <div class="row mt-2">                                                    
                                                    <div class="col-sm-12 col-md-4 col-lg-4">
                                                        <div class="form-group">
                                                            <label for="id_ip_interna"
                                                                class="text-sm text-uppercase font-weight-lighter"
                                                                style="font-family: Arial, Helvetica, sans-serif;"><i class="fa fa-network-wired"></i>
                                                                IP INTERNA:
                                                            </label>
                                                            {{ form.ip_interna }}
                                                        </div>
                                                    </div>

                                                    <div class="col-sm-12 col-md-4 col-lg-4">
                                                        <div class="form-group">
                                                            <label for="id_ip_externa"
                                                                class="text-sm text-uppercase font-weight-lighter"
                                                                style="font-family: Arial, Helvetica, sans-serif;"><i class="fa fa-network-wired"></i>
                                                                IP EXTERNA:
                                                            </label>
                                                            {{ form.ip_externa }}
                                                        </div>
                                                    </div>

                                                    <div class="col-sm-1 col-md-4 col-lg-4">
                                                        <div class="form-group">
                                                            <label for="id_gateway"
                                                                class="text-sm text-uppercase text-black-50"
                                                                style="font-family: Arial, Helvetica, sans-serif;">GATEWAY:
                                                            </label>
                                                            {{ form.gateway }}
                                                        </div>
                                                    </div>                                                    
                                                </div>

                                                <!-- fila 3 -->
                                                <div class="row mt-2">                                                                                                                                                      

                                                    <div class="col-sm-12 col-md-4 col-lg-4">
                                                        <div class="form-group">
                                                            <label for="id_signal_min"
                                                                class="text-sm text-uppercase text-black-50"
                                                                style="font-family: Arial, Helvetica, sans-serif;">SEÑAL MINIMA:
                                                            </label>
                                                            {{ form.signal_min }}
                                                        </div>
                                                    </div>     

                                                    <div class="col-sm-12 col-md-4 col-lg-4">
                                                        <div class="form-group">
                                                            <label for="id_signal_actual"
                                                                class="text-sm text-uppercase text-black-50"
                                                                style="font-family: Arial, Helvetica, sans-serif;">SEÑAL ACTUAL:
                                                            </label>
                                                            {{ form.signal_actual }}
                                                        </div>
                                                    </div>   
                                                                                                       
                                                    <div class="col-sm-12 col-md-4 col-lg-4">
                                                        <div class="form-group">
                                                            <label for="id_notas"
                                                                class="text-sm text-uppercase text-black-50"
                                                                style="font-family: Arial, Helvetica, sans-serif;">NOTAS:
                                                            </label>
                                                            {{ form.notas }}
                                                        </div>
                                                    </div>
                                                </div>

                                                <div class="dropdown-divider"></div>
                                                <div class="row">    
                                                    <div class="col-sm-12 col-md-2 col-lg-2"></div>  

                                                    <div class="col-sm-12 col-md-4 col-lg-4">
                                                        <button type="submit" class="btn btn-success btn-block"><i
                                                            class="fa fa-save"></i><span> Guardar</span>
                                                        </button>
                                                    </div>

                                                    <div class="col-sm-12 col-md-4 col-lg-4">
                                                        <a href="{% url 'app_equipos:antenas_list' %}"
                                                            class="btn btn-info btn-block"><i class="fas fa-window-close"></i><span> Cancelar</span>
                                                        </a>
                                                    </div> 
                                                    <div class="col-sm-12 col-md-2 col-lg-2"></div>                                                  
                                                </div>

                                            </div>
                                            <!-- /.card-body -->
                                        </div>
                                        <!-- /.card-header -->
                                    </div>
                                </div>
                            </div>
                        <!-- /.card -->
                        </form>
                        <!-- ./form -->
                    </div>
                </div>
            </div>
        </div>
</div>
</section>
<!-- /.container-fluid -->
</div>
<!-- /.content-header -->
{% endblock content %}


{% block js_page %}
<script>  
  // carga del DOM
  $(function () {
    //Initialize Select2 Elements
    $('#id_cliente').select2()

    //Initialize Select2 Elements
    $('#id_cliente').select2({
      theme: 'bootstrap4'
    })   

    $('#id_emisora').select2()

    $('#id_emisora').select2({
      theme: 'bootstrap4'
    }) 

  });
</script>
{% endblock js_page %}

app_equipos/templates/app_equipos/emisoras_del.html
{% extends 'bases/home.html' %}

{% load static %}

{% block content %}
<!-- Content Header (Page header) -->
<div class="content-header">
  <section class="content">
    <div class="container-fluid">
      <div class="row">
        <div class="col-4">
          <form method="post">
            {% csrf_token %}
            <!-- Input addon -->
            <!-- card -->
            <div class="card card-danger">                            
              <div class="card-header">
                <h3 class="card-title text-uppercase">Emisoras</h3>

                <div class="col-auto d-flex justify-content-end">
                  <i class="far fa-question-circle fa-2x text-gray-300"></i>                           
                </div>
              </div>

              <!-- card-body -->
              <div class="card-body">
                <div class="col-12">
                  <div class="font-weight-light mb-1" style="font-family: Arial, Helvetica, sans-serif; font-size: large;"> ¿Deseas eliminar la emisora:
                    <span class="text-primary" style="text-decoration-line: line-through;"> {{ obj.nombre }}</span> ?
                  </div>

                  <img class="card-img-top p-4" src="{% static 'dist/img/remove-antena.svg' %}" height="280px" alt="modem">
                    
                    <div class="row mt-2">
                      <div class="col-6">
                        <button type="submit" class="btn btn-danger btn-block"><i class="fas fa-check-circle"></i> Si, Eliminar</button>
                      </div>

                      <div class="col-6">
                        <a href="{% url 'app_equipos:emisoras_list' %}" class="btn btn-success btn-block"><span class="fas fa-window-close"></span> Cancelar</a>
                      </div>
                    </div>                                                            
                </div> 
                                
              </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card-header -->
          </div>        
        <!-- /.card -->
        </form>
        <!-- ./form -->
      </div>
    </div>
</div>
</section>
<!-- /.container-fluid -->
</div>
<!-- /.content-header -->
{% endblock content %}